# importing fiona before shapely leads to failed assertions in 
# GEOS's AbstractSTRTree.cpp.
#
# Note: fiona's extension modules link libgeos_c: it is a 
# sub-dependency via libgdal.
import fiona

# when shapely is imported, the Python interpreter will locate
# and dlopen libgeos_c.
from shapely.geometry import Point
from shapely.geos import geos_version
from shapely.ops import unary_union

# importing fiona after shapely has no adverse affects.
# import fiona

print(geos_version)

SHAPES = [Point(i, i).buffer(1.5) for i in range(20)]
for i, s in enumerate(SHAPES):
    print(i, s.is_valid)
    print(i, s.wkt)
    print(i, s.area, s.length)
    print(i, s.intersects(Point(10, 10).buffer(8.0)))

union = unary_union(SHAPES)
print(union)
